﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace LoadImplicitTheme
{
    static class SharedDictionaryManager
    {
        public static ResourceDictionary SharedDictionary
        {
            get
            {
                if (_sharedDictionary == null)
                {
                    System.Uri resourceLocater =
                        new System.Uri("/LoadImplicitTheme;component/Office2013.xaml",
                                        System.UriKind.Relative);

                    _sharedDictionary =
                        (ResourceDictionary)Application.LoadComponent(resourceLocater);
                }

                return _sharedDictionary;
            }
        }

        public static void LoadImplicitTheme(string theme)
        {
            if (theme == "Windows8")
            {
                LoadTheme(new Uri("/LoadImplicitTheme;component/Windows8.xaml", System.UriKind.Relative));
            }
            else if (theme == "Office2013")
            {
                LoadTheme(new Uri("/LoadImplicitTheme;component/Office2013.xaml", System.UriKind.Relative));
            }
        }

        private static void LoadTheme(Uri theme)
        {
            if (_sharedDictionary != null)
            {
                _sharedDictionary.MergedDictionaries.Clear();
                _sharedDictionary.MergedDictionaries.Add((ResourceDictionary)Application.LoadComponent(theme));
            }
        }

        private static ResourceDictionary _sharedDictionary;
    }
}
